// To compile, perform:
// gcc -std=c99 doubleRecursion.c -o doubleRecursion
// Run
// ./doubleRecursion

#include <stdio.h>
#include <stdlib.h>

int multiply(int a, int b){
    // return a*b if a > 0 and 0 otherwise
    if (a > 0)
        return( multiply((a-1),b) + b );
    else
        return 0;
    
}

int tarai(int x, int y, int z){
    // Tarai function by Ikuo Takeuchi
    if(x <= y)
        return y;
    else
        return( tarai( tarai(x-1,y,z), tarai(y-1,z,x), tarai(z-1,x,y) ) );
    
}

int mc(int n){
    // McCarthy 91 function
    if(n > 100)
        return n-10;
    else
        return mc( mc(n+11) );
}

int main()
{
    int a = 10;
    int b = 2;
    printf("%i times %i equals %i\n", a, b, multiply(a,b) );
    
    int x = 10;
    int y = 5;
    int z = 1;
    printf("tarai(%i,%i,%i) is %i\n", x, y, z, tarai(x,y,z) );
    
    int n = 10;
    printf("mc(%i) is %i\n", n, mc(n) );
    
    return EXIT_SUCCESS;
}
